#!/bin/sh
# $Id: $
#
# Component:    TivoliPlus (un-installation utilities for English machines ONLY)
#
# $Source: $
# $Revision: $
#
# Description:  Utility script to uninstall the TSD EI.
#		Can be run from any MN/user id w/ admin role.
#
# External Variable References / Initialization:
#
# Author:       Shane Otis
#               Tivoli Systems, Inc.
# Modifications:
#
# (C) COPYRIGHT Tivoli Systems, Inc. 1998, 1999
# Unpublished Work
# All Rights Reserved
# Licensed Material - Property of Tivoli Systems, Inc.
#

#set -x

if [ -z $BINDIR ] || [ -z $DBDIR ]; then
   echo "Set Tivoli environment before proceeding..."; exit 1;
fi

wchkdb -u; sleep 15

#
# get region name
#
IRO=`wlookup InterRegion`
IRONAME=`idlattr -t -g $IRO name string`
IRONAME=`eval echo $IRONAME`

########################
#
# delete tasks, jobs
#

#Gateway Tasks:
wdeljob		"Report_NSM_Gateway_Stats (TSD)"	"Gateway Tasks"
wdeljob		"Report_NSM_Gateway_Connections (TSD)"	"Gateway Tasks"
wdeltask	"Report_Gateway_Stats"			"Gateway Tasks"
wdeltask	"Report_Gateway_Connections"		"Gateway Tasks"
wdeltask	"Report_NSM_Gateway_Stats"		"Gateway Tasks"
wdeltask	"Report_NSM_Gateway_Connections"	"Gateway Tasks"
wdel @TaskLibrary:"Gateway Tasks"

#Mail Configuration:
wdeljob		"Configure_Mail_Gateway (TSD)"	"Mail Configuration"
wdeltask	"Configure_Mail_Gateway"	"Mail Configuration"
wdel @TaskLibrary:"Mail Configuration"

#Mail Tasks:
wdeljob		"Start_Mail_Gateway (TSD)"	"Mail Tasks"
wdeljob		"Stop_Mail_Gateway (TSD)"	"Mail Tasks"
wdeljob		"Mail_Gateway_Status (TSD)"	"Mail Tasks"
wdeltask	"Start_Mail_Gateway"		"Mail Tasks"
wdeltask	"Stop_Mail_Gateway"		"Mail Tasks"
wdeltask	"Mail_Gateway_Status"		"Mail Tasks"
wdel @TaskLibrary:"Mail Tasks"

#Master GUI Tasks:
wdeljob		"Stop_Master (TSD)"		"Master GUI Tasks"
wdeljob		"Start_Master (TSD)"		"Master GUI Tasks"
wdeljob		"Master_Status (TSD)"		"Master GUI Tasks"
wdeltask	"Start_Master"			"Master GUI Tasks"
wdeltask	"Master_Status"			"Master GUI Tasks"
wdeltask	"Stop_Master"			"Master GUI Tasks"
wdel @TaskLibrary:"Master GUI Tasks"

#Monitor Configuration:
wdeljob		"Configure_Monitor (TSD)"	"Monitor Configuration"
wdeltask	"Configure_Monitor"		"Monitor Configuration"
wdel @TaskLibrary:"Monitor Configuration"

#Monitor Tasks:
wdeljob		"Start_Monitor (TSD)"		"Monitor Tasks"
wdeljob		"Monitor_Status (TSD)"		"Monitor Tasks"
wdeljob		"Stop_Monitor (TSD)"		"Monitor Tasks"
wdeltask	"Start_Monitor"			"Monitor Tasks"
wdeltask	"Stop_Monitor"			"Monitor Tasks"
wdeltask	"Monitor_Status"			"Monitor Tasks"
wdel @TaskLibrary:"Monitor Tasks"

#NSM Configuration:
wdeljob		"Configure_NSM_Commands (TSD)" 	"NSM Configuration"
wdeltask	"Configure_NSM_Commands" 	"NSM Configuration"
wdel @TaskLibrary:"NSM Configuration"

#NSM Tasks:
wdeljob		"Open_Problem_Ticket (TSD)" 	"NSM Tasks"
wdeljob		"Update_Problem_Ticket (TSD)" 	"NSM Tasks"
wdeljob		"Close_Problem_Ticket (TSD)" 	"NSM Tasks"
wdeljob		"NSM_Eventd_Status (TSD)" 	"NSM Tasks"
wdeljob		"NSM_Queryd_Status (TSD)" 	"NSM Tasks"
wdeljob		"Start_NSM_Eventd (TSD)" 	"NSM Tasks"
wdeljob		"Start_NSM_Queryd (TSD)" 	"NSM Tasks"
wdeljob		"Stop_NSM_Eventd (TSD)" 		"NSM Tasks"
wdeljob		"Stop_NSM_Queryd (TSD)" 		"NSM Tasks"
wdeltask	"Open_Problem_Ticket" 		"NSM Tasks"
wdeltask	"Close_Problem_Ticket" 		"NSM Tasks"
wdeltask	"Update_Problem_Ticket" 		"NSM Tasks"
wdeltask	"Stop_NSM_Queryd" 		"NSM Tasks"
wdeltask	"Start_NSM_Eventd" 		"NSM Tasks"
wdeltask	"Stop_NSM_Eventd" 		"NSM Tasks"
wdeltask	"NSM_Eventd_Status" 		"NSM Tasks"
wdeltask	"Start_NSM_Queryd" 		"NSM Tasks"
wdeltask	"NSM_Queryd_Status" 		"NSM Tasks"
wdel @TaskLibrary:"NSM Tasks"

#Server Configuration:
wdeljob		"Configure_TSD_Server (TSD)"	"Server Configuration"
wdeltask	"Configure_TSD_Server"		"Server Configuration"
wdel @TaskLibrary:"Server Configuration"

#Server Tasks:
wdeljob		"Start_TSD_Server_Agents (TSD)"		"Server Tasks"
wdeljob		"Recycle_TSD_Server_Agents (TSD)"	"Server Tasks"
wdeljob		"Stop_TSD_Server_Agents (TSD)"		"Server Tasks"
wdeljob		"TSD_Server_Dispatcher_Status (TSD)"	"Server Tasks"
wdeljob		"Stop_TSD_Server_Dispatcher (TSD)"	"Server Tasks"
wdeljob		"Start_TSD_Server_Dispatcher (TSD)"	"Server Tasks"
wdeljob		"Report_TSD_Server_Stats (TSD)"		"Server Tasks"
wdeltask	"Start_TSD_Server_Agents"		"Server Tasks"
wdeltask	"Recycle_TSD_Server_Agents"		"Server Tasks"
wdeltask	"Start_TSD_Server_Dispatcher"		"Server Tasks"
wdeltask	"Stop_TSD_Server_Dispatcher"		"Server Tasks"
wdeltask	"Stop_TSD_Server_Agents"		"Server Tasks"
wdeltask	"Report_TSD_Server_Stats"		"Server Tasks"
wdeltask	"TSD_Server_Dispatcher_Status"		"Server Tasks"
wdel @TaskLibrary:"Server Tasks"

#Slave GUI Tasks:
wdeljob		"Slave_Status (TSD)"	"Slave GUI Tasks"
wdeljob		"Stop_Slave (TSD)"	"Slave GUI Tasks"
wdeljob		"Start_Slave (TSD)"	"Slave GUI Tasks"
wdeltask	"Stop_Slave"		"Slave GUI Tasks"
wdeltask	"Slave_Status"		"Slave GUI Tasks"
wdeltask	"Start_Slave"		"Slave GUI Tasks"
wdel @TaskLibrary:"Slave GUI Tasks"

#TEC Configuration:
wdeljob		"Setup_TEC_Event_Server (TSD)" 	"TEC Configuration"
wdeltask	"Setup_TEC_Event_Server" 	"TEC Configuration"
wdel @TaskLibrary:"TEC Configuration"

#TSD Client File Package:
wdeljob		"Configure_TSD_Client_File_Package (TSD)"	"TSD Client File Package"
wdeltask	"Configure_TSD_Client_File_Package"		"TSD Client File Package"
wdel @TaskLibrary:"TSD Client File Package"

#TSD Configuration:
wdeljob		"About_TSD_Enterprise_Interface (TSD)"		"TSD Configuration"
wdeltask	"About_TSD_Enterprise_Interface"		"TSD Configuration"
wdel @TaskLibrary:"TSD Configuration"

#TSD File Package:
wdeljob		"Configure_TSD_File_Package (TSD)"	"TSD File Package"
wdeltask	"Configure_TSD_File_Package"		"TSD File Package"
wdel @TaskLibrary:"TSD File Package"

wdel @TaskLibrary:"TSD Utility Task Library"

#TSD Problem Management:
wdeljob		"StartPM (TSD)"	"TSD Problem Management"
wdeltask	"StartPM"	"TSD Problem Management"
wdel @TaskLibrary:"TSD Problem Management"


wdel @ProductInfo:TSDModule


########################
#
# for "for" loops
#
OIFS=$IFS
IFS="
"

########################
#
# delete subscription lists
#

wcd /Regions/TSD
if [ $? -eq 1 ]; then exit 1; fi

sls=`wls /Regions/TSD |grep Hosts$`

for x in $sls; do
   echo unsubscribing $x ...
   wunsub -a "$x"
   echo deleting $x ...
   wdel @ProfileManager:"$x"
done

########################
#
# delete indicator collections
#

wcd /Regions/TSD
if [ $? -eq 1 ]; then exit 1; fi

ics=`wls /Regions/TSD |grep Indicators$`

for x in $ics; do
   echo deleting IndicatorCollection $x ...
   wdel @IndicatorCollection:"$x"
done

########################
#
# delete monitors 
#

wcd /Regions/TSD
if [ $? -eq 1 ]; then exit 1; fi

mons=`wls /Regions/TSD |grep Monitors$`

for x in $mons; do
   echo unsubscribing $x ...
   wunsub -a "$x"
   echo deleting $x ...
   wdel @SentryProfile:"$x"
   wdel @ProfileManager:"$x"

   if [ $? -ne 0 ] ;then
      OID=`wls -l "$x" | cut -f1 -d"#"`
      wregister -r ProfileManager "$x" $OID
      wdel @ProfileManager:"$x"
      wrm "$x"
   fi
done

mons=`wlookup -ar MonitoringCapabilityCollection | cut -f1 \
          | grep Tivoli_Systems__Inc__[a-zA-Z_]*_Monitors__V6_0`
for x in $mons; do
   echo removing MonitoringCapabilityCollection $x ...
   wdel @MonitoringCapabilityCollection:"$x"
done

########################
#
# delete file packages left in profile managers
#

nest_fps=`wls @ProfileManager:"TSD Filepacks"`
client_fps=`wls @ProfileManager:"TSD Client File Package"`
server_fps=`wls @ProfileManager:"TSD File Package"`

for x in $nest_fps $client_fps $server_fps; do
   echo deleting filepack $x ...
   wdel @FilePackage:"$x"
done

wunsub -a @ProfileManager:"TSD Filepacks"
wunsub -a @ProfileManager:"TSD Client File Package"
wunsub -a @ProfileManager:"TSD File Package"

wdel @ProfileManager:"TSD Filepacks"
wdel @ProfileManager:"TSD Client File Package"
wdel @ProfileManager:"TSD File Package"

########################
#
# delete labels
#
IFS=$OIFS

wcd /Administrators/Root_${IRONAME}/TSD
if [ $? -eq 1 ]; then exit 1; fi

wls -l /Administrators/Root_${IRONAME}/TSD | while read x; do

   # need to do this again, since we forked 
   wcd /Administrators/Root_${IRONAME}/TSD
   if [ $? -eq 1 ]; then exit 1; fi

   collection=`echo $x|grep Collection|cut -f2- -d" "`

   if [ -n "$collection" ]; then
      echo "entering $collection..."
      wcd "$collection"

OIFS=$IFS
IFS="
"
      labels=`wls`
      for y in $labels; do
         wrm "$y"
      done

IFS=$OIFS

      wcd ..
      wrm "$collection"
   fi
done

########################
#
# clean up some straggly stuff :-)
#

OIFS=$IFS
IFS="
"

wcd /Administrators/Root_${IRONAME}/TSD
if [ $? -eq 1 ]; then exit 1; fi

list=`wls`
for x in $list; do
   echo removing $x ...
   wrm "$x"
done

wcd /Regions/TSD
if [ $? -eq 1 ]; then exit 1; fi

list=`wls`
for x in $list; do
   echo removing $x ...
   wrm "$x"
done

########################
#
# policy regions
#

wcd /

list=`wls /Regions/TivoliPlus`
if [ -z "$list" ]; then
   wdelpr  /Regions/TivoliPlus
else
   echo  "warning: Policy Region /Regions/TivoliPlus is NOT empty."
fi

list=`wls /Regions/TSD`
if [ -z "$list" ]; then
   wdelpr  /Regions/TSD
else
   echo  "warning: Policy Region /Regions/TSD is NOT empty."
fi

########################
#
# TSD collection icon
#

list=`wls /Administrators/Root_${IRONAME}/TSD`
if [ -z "$list" ]; then
   wrm /Administrators/Root_${IRONAME}/TSD
else
   echo  "warning: Collection /Administrators/Root_${IRONAME}/TSD is NOT empty."
fi

exit 0
